<?php
/*
 * Xoops header and important includes
 */

include('../../mainfile.php');
$xoopsOption['template_main'] = 'first_page.html';

include(XOOPS_ROOT_PATH . '/header.php');
include(XOOPS_ROOT_PATH . '/modules/picito/include/gd.class.php');
include(XOOPS_ROOT_PATH . '/modules/picito/include/saver.php');

/*
 * Create upload directory if it doesn't exist
 */

if(!is_dir(XOOPS_ROOT_PATH . '/uploads/picito/'))
{
	mkdir(XOOPS_ROOT_PATH . '/uploads/picito/', 0777);
	mkdir(XOOPS_ROOT_PATH . '/uploads/picito/thumbs/', 0777);
}

/*
 * Function to clean up upload name
 */

function filenameCleanup($str)
{
	$str = preg_replace('/\ /', '_', $str);
	$str = preg_replace('/[^a-zA-Z_\.]/', '', $str);
	$str = strtolower($str);
	
	return $str;
}

/*
 * Upload a picture
 */

$file_posted = '0';

if(isset($_POST['uploadpic']) && $_FILES['file']['size'] != 0)
{
	$file_posted = '1';
	
	$allowed = array('image/gif', 'image/jpeg', 'image/png', 'image/x-png', 'image/pjpeg');
	
	if(!in_array($_FILES['file']['type'], $allowed))
	{
		print "<script>history.go(-1);</script>";
		die();
	}
	if($_FILES['file']['size'] > returnSetting('0'))
	{
		print "<script>history.go(-1);</script>";
		die();
	}
	
	$file = basename($_FILES['file']['name']);
	$file = filenameCleanup($file);
	$file = rand() . '_' . $file;
	
	$picroot = XOOPS_ROOT_PATH . '/uploads/picito/';
	$path = $picroot . $file;
	
	move_uploaded_file($_FILES['file']['tmp_name'], $path);
	
	$gd = new GD($path);
	$gd -> Resize(returnSetting('2'), returnSetting('2'));
	$path_thumb = $picroot . 'thumbs/' . $file;
	$gd -> Save($path_thumb, '100%');
	
	$fontpath = XOOPS_ROOT_PATH . '/modules/picito/include/tahoma.ttf';
	
	if(!empty($_POST['resizer']))
	{
		$gd = new GD($path);
		$gd -> Resize($_POST['resizer'], $_POST['resizer']);
		$gd->Add_Text(returnSetting('1'), 5, returnSetting('3'), BOTTOM, CENTER, $fontpath); 
		$path_resized = $picroot . $file;
		$gd -> Save($path_resized, '100%');
	}
	else
	{
		$gd = new GD($path);
		$gd->Add_Text(returnSetting('1'), 5, returnSetting('3'), BOTTOM, CENTER, $fontpath); 
		$path_resized = $picroot . $file;
		$gd -> Save($path_resized, '100%');
	}
	
	// Insert data into table
	$sql = "INSERT INTO " . $xoopsDB->prefix('picito_uploads') . " 
	(filename, filesize, date, time, filetype, ip, description) VALUES (
	'$file',
	'" . $_FILES['file']['size'] . "',
	'" . date('Y-m-d') . "',
	'" . date('H:i:s') . "',
	'" . $_FILES['file']['type'] . "',
	'" . $_SERVER['REMOTE_ADDR'] . "',
	'" . mysql_real_escape_string($_POST['description']) . "'
	)";
	
	$xoopsDB->query($sql);
	
	$xoopsTpl->assign('image_big', XOOPS_URL . '/uploads/picito/' . $file);
	$xoopsTpl->assign('image_small', XOOPS_URL . '/uploads/picito/thumbs/' . $file);
}

/*
 * Assign everything else to Xoops template engine
 */

$xoopsTpl->assign('file_posted', $file_posted);
$xoopsTpl->assign('module_title', _LANG_XOOPS_PICITO_01_);
$xoopsTpl->assign('module_desc', _LANG_XOOPS_PICITO_02_);
$xoopsTpl->assign('form_file', _LANG_XOOPS_PICITO_03_);
$xoopsTpl->assign('upload_button', _LANG_XOOPS_PICITO_04_);
$xoopsTpl->assign('bbcode', _LANG_XOOPS_PICITO_05_);
$xoopsTpl->assign('htmlcode', _LANG_XOOPS_PICITO_06_);
$xoopsTpl->assign('directlink', _LANG_XOOPS_PICITO_13_);
$xoopsTpl->assign('resize_orig', _LANG_XOOPS_PICITO_14_);
$xoopsTpl->assign('nope', _LANG_XOOPS_PICITO_15_);
$xoopsTpl->assign('descript', _LANG_XOOPS_PICITO_16_);
$xoopsTpl->assign('allowedtext', _LANG_XOOPS_PICITO_17_);
$xoopsTpl->assign('newupload', _LANG_XOOPS_PICITO_18_);

/*
 * Xoops footer
 */

include(XOOPS_ROOT_PATH."/footer.php");
?>